Loading...
Searching...
No Matches
Sip_route

## Data Structures

struct | sip_route_s
| Structure for Route and Record-Route header fields. More...

## Macros

#define | sip_route(sip)
| Access a SIP Route header structure sip_route_t from sip_t.
#define | SIP_ROUTE_INIT()
| Initializer for structure sip_route_t.
#define | SIPTAG_ROUTE(x)
| Tag list item for pointer to a Route header structure sip_route_t.
#define | SIPTAG_ROUTE_REF(x)
| Tag list item for reference to a Route header pointer.
#define | SIPTAG_ROUTE_STR(s)
| Tag list item for string with Route header value.
#define | SIPTAG_ROUTE_STR_REF(x)
| Tag list item for reference to a Route header string.

## Typedefs

typedef struct sip_route_s | sip_route_t
| @

## Functions

issize_t | sip_route_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Route header.
issize_t | sip_route_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Route header.
sip_route_t * | sip_route_init (sip_route_t x[1])
| Initialize a structure sip_route_t.
int | sip_is_route (sip_header_t const *header)
| Test if header object is instance of sip_route_t.
sip_route_t * | sip_route_dup (su_home_t *home, sip_route_t const *hdr))
| Duplicate a list of Route header header structures sip_route_t.
sip_route_t * | sip_route_copy (su_home_t *home, sip_route_t const *hdr))
| Copy a list of Route header header structures sip_route_t.
sip_route_t * | sip_route_make (su_home_t *home, char const *s))
| Make a Route header structure sip_route_t.
sip_route_t * | sip_route_format (su_home_t *home, char const *fmt,...)))
| Make a Route header from formatting result.
sip_route_t * | sip_route_create (su_home_t *home, url_t const *url, url_t const *maddr)
| Create a Route header object.
sip_route_t * | sip_route_remove (msg_t *msg, sip_t *sip)
| Get first route header and remove it from its fragment chain.
sip_route_t * | sip_route_pop (msg_t *msg, sip_t *sip)
| Get last route header and remove it from its fragment chain.
sip_route_t * | sip_route_follow (msg_t *msg, sip_t *sip)
| Get first route header and rewrite the RequestURI.
int | sip_route_is_loose (sip_route_t const *r)
| Check if route header has lr param.
sip_route_t * | sip_route_reverse_as (su_home_t *home, msg_hclass_t *hc, sip_route_t const *route)
| Reverse a route header (Route, Record-Route, Path, Service-Route).
sip_route_t * | sip_route_reverse (su_home_t *home, sip_route_t const *route)
| Reverse a Route header.
sip_route_t * | sip_route_fixdup_as (su_home_t *home, msg_hclass_t *hc, sip_route_t const *route)
| Fix and duplicate a route header (Route, Record-Route, Path, Service-Route).
sip_route_t * | sip_route_fixdup (su_home_t *home, sip_route_t const *route)
| Fix and duplicate a Route header.
sip_route_t * | sip_route_fix (sip_route_t *route)
| Fix Route header.

## Variables

msg_hclass_t | sip_route_class []
| Header class for Route header.
tag_typedef_t | siptag_route
| Tag for Route header object.
tag_typedef_t | siptag_route_str
| Tag for string with Route header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ROUTE_INIT

#define SIP_ROUTE_INIT | ( |  | ) |

Initializer for structure sip_route_t.

A static sip_route_t structure for Route header must be initialized with the SIP_ROUTE_INIT() macro. For instance,

sip_route_t sip_route = SIP_ROUTE_INIT;
sip_route
#define sip_route(sip)
Access a SIP Route header structure sip_route_t from sip_t.
Definition sip_protos.h:845
SIP_ROUTE_INIT
#define SIP_ROUTE_INIT()
Initializer for structure sip_route_t.
Definition sip_protos.h:862
sip_route_t
struct sip_route_s sip_route_t
@
Definition sip.h:187

## SIPTAG_ROUTE

#define SIPTAG_ROUTE | ( |  | x | ) |

Tag list item for pointer to a Route header structure sip_route_t.

The SIPTAG_ROUTE() macro is used to include a tag item with a pointer to a sip_route_t structure in a tag list.

Parameters

  x | pointer to a sip_route_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ROUTE_REF().

## SIPTAG_ROUTE_STR

#define SIPTAG_ROUTE_STR | ( |  | s | ) |

Tag list item for string with Route header value.

The SIPTAG_ROUTE_STR() macro is used to include a tag item with a string containing value of a sip_route_t header in a tag list.

Parameters

  s | pointer to a string containing Route header value, or NULL.

The string in SIPTAG_ROUTE_STR() can be converted to a sip_route_t header structure by giving the string s has second argument to function sip_route_make().

The corresponding tag taking reference parameter is SIPTAG_ROUTE_STR_REF().

## Typedef Documentation

## sip_route_t

typedef struct sip_route_s sip_route_t

@

The Route headers is used to store the route set of a transaction. The Route header is defined in RFC 3261 as follows:

Route = "Route" HCOLON route-param *(COMMA route-param)
route-param = name-addr *( SEMI rr-param )

The parsed Route header is stored in sip_route_t structure.

The structure sip_route_t contains representation of SIP Route header.

The sip_route_t is defined as follows:

typedef struct sip_route_s {
sip_common_t r_common[1]; // Common fragment info
sip_route_t *r_next; // Link to next @Route
char const *r_display; // Display name
url_t r_url[1]; // @Route URL
msg_param_t const *r_params; // List of route parameters
} sip_route_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_route_s
Structure for Route and Record-Route header fields.
Definition sip.h:681
sip_route_s::r_display
char const * r_display
Display name.
Definition sip.h:684
sip_route_s::r_next
sip_route_t * r_next
Link to next.
Definition sip.h:683
sip_route_s::r_url
url_t r_url[1]
Route URL
Definition sip.h:685
sip_route_s::r_common
sip_common_t r_common[1]
Common fragment info.
Definition sip.h:682
sip_route_s::r_params
msg_param_t const * r_params
List of route parameters.
Definition sip.h:686
url_t

## Function Documentation

## sip_is_route()

int sip_is_route | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_route_t.

Check if the header class is an instance of Route header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header route
  0 | (false) otherwise

## sip_route_copy()

sip_route_t * sip_route_copy | ( | su_home_t * | home,
|  | sip_route_t const * | hdr )

inline

Copy a list of Route header header structures sip_route_t.

The function sip_route_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  route = sip_route_copy(home, sip->sip_route);
  sip_route_copy
  sip_route_t * sip_route_copy(su_home_t *home, sip_route_t const *hdr))
  Copy a list of Route header header structures sip_route_t.
  Definition sip_protos.h:992

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_route_create()

sip_route_t * sip_route_create | ( | su_home_t * | home,
|  | url_t const * | url,
|  | url_t const * | maddr )

Create a Route header object.

Creates a route entry from two URLs; first one provides the URL, second maddr parameter and port.

Parameters

  home | memory home
  url | route URL
  maddr | optional route address and port

Returns
  Returns a pointer to newly created Route header object when successful, or NULL upon an error.

## sip_route_dup()

sip_route_t * sip_route_dup | ( | su_home_t * | home,
|  | sip_route_t const * | hdr )

inline

Duplicate a list of Route header header structures sip_route_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  route = sip_route_dup(home, sip->sip_route);
  sip_route_dup
  sip_route_t * sip_route_dup(su_home_t *home, sip_route_t const *hdr))
  Duplicate a list of Route header header structures sip_route_t.
  Definition sip_protos.h:949

Returns
  A pointer to the newly duplicated sip_route_t header structure, or NULL upon an error.

## sip_route_fix()

sip_route_t * sip_route_fix | ( | sip_route_t * | route | ) |

Fix Route header.

If URI has no parameters and the header contains a single ``;lr header parameter, the "lr" is moved as URI parameter.

## sip_route_fixdup()

sip_route_t * sip_route_fixdup | ( | su_home_t * | home,
|  | sip_route_t const * | route )

Fix and duplicate a Route header.

Copy a route header like Record-Route or Path as Route.

## sip_route_format()

sip_route_t * sip_route_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Route header from formatting result.

Make a new sip_route_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_route_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_route_init()

sip_route_t * sip_route_init | ( | sip_route_t | x[1] | ) |

inline

Initialize a structure sip_route_t.

An sip_route_t structure for Route header can be initialized with the sip_route_init() function/macro. For instance,

sip_route_t sip_route;
sip_route_init(&sip_route);
sip_route_init
sip_route_t * sip_route_init(sip_route_t x[1])
Initialize a structure sip_route_t.
Definition sip_protos.h:880

## sip_route_is_loose()

int sip_route_is_loose | ( | sip_route_t const * | r | ) |

Check if route header has lr param.

"lr" param can be either URL or header parameter.

## sip_route_make()

sip_route_t * sip_route_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Route header structure sip_route_t.

The function sip_route_make() makes a new sip_route_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_route_t header structure, or NULL upon an error.

## sip_route_reverse()

sip_route_t * sip_route_reverse | ( | su_home_t * | home,
|  | sip_route_t const * | route )

Reverse a Route header.

Reverse A route header like Record-Route or Path.

## Variable Documentation

## sip_route_class

msg_hclass_t sip_route_class[]

extern

Header class for Route header.

The header class sip_route_class defines how a SIP Route header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_route_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.